Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1444552 - Review Request: python-sortedcontainers - A pure Python sorted collections library [NEEDINFO]
Summary: Review Request: python-sortedcontainers - A pure Python sorted collections li...
Keywords:
Status: CLOSED DUPLICATE of bug 1487884
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-DEADREVIEW
TreeView+ depends on / blocked
 
Reported: 2017-04-22 08:29 UTC by Eric Smith
Modified: 2017-09-03 01:22 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-09-03 01:22:36 UTC
quantum.analyst: needinfo? (spacewar)


Attachments (Terms of Use)

Description Eric Smith 2017-04-22 08:29:34 UTC
Spec URL: https://fedorapeople.org/~brouhaha/python-sortedcontainers/python-sortedcontainers.spec
SRPM URL: https://fedorapeople.org/~brouhaha/python-sortedcontainers/python-sortedcontainers-1.5.7-1.fc25.src.rpm
Description: SortedContainers is an Apache2 licensed sorted collections library,
written in pure-Python, and fast as C-extensions.
Fedora Account System Username: brouhaha

Comment 1 Iryna Shcherbina 2017-04-25 12:45:17 UTC
Hi Eric,

* You can run test like this:

%check
nosetests-%{python2_version}
nosetests-%{python3_version}

But make sure to add build time dependency (BuildRequires) on python2-nose and python3-nose.

* Also please avoid using wildcards in %files section. You can change it to:

%{python3_sitelib}/%{modname}
%{python3_sitelib}/%{modname}-{%version}-py*.egg-info

Comment 2 nicolas.vieville 2017-06-07 16:35:27 UTC
Hello,

As a new comer in packaging for Fedora, I've to make informal review of others review request in order to be sponsored. 
I propose you to make an informal review of this request. Please feel free to make any comment about this.

Summary of review potential problems.

MUST 
   - License field in the package spec file matches the actual license.
     265 files have unknown license.
     Apache (v2.0) licence is OK, so I think that 265 files are OK (not
     necessary to add licence field in each one)?
   - Package must own all directories that it creates.
     I've not checked this item in the review below, because maybe you should
     follow Iryna advise about using wildcards in %files section. Please, don't
     forget to modify the 2 sides of the %files section (the python2 one and
     the python3 one).

SHOULD
   - %check is present and all tests pass. Maybe you should here follow Iryna
     advise too and add the necessary items in order to run the unit tests
     provided in the upstream directory (one comment on the github page says 
     that these unit tests "run out of the box on Python 2 and 3." and praises
     the code quality). It would probably worth having these tests included
     in this package.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "*No copyright* Apache", "Unknown or
     generated". 265 files have unknown license.
[x]: License file installed when any subpackage combination is installed.
[?]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.6/site-
     packages, /usr/lib/python3.6
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-sortedcontainers , python3-sortedcontainers
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-sortedcontainers-1.5.7-1.fc27.noarch.rpm
          python3-sortedcontainers-1.5.7-1.fc27.noarch.rpm
          python-sortedcontainers-1.5.7-1.fc27.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
python3-sortedcontainers (rpmlib, GLIBC filtered):
    python(abi)

python2-sortedcontainers (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python3-sortedcontainers:
    python3-sortedcontainers
    python3.6dist(sortedcontainers)
    python3dist(sortedcontainers)

python2-sortedcontainers:
    python-sortedcontainers
    python2-sortedcontainers
    python2.7dist(sortedcontainers)
    python2dist(sortedcontainers)



Source checksums
----------------
https://github.com/grantjenks/sorted_containers/archive/v1.5.7/sorted_containers-1.5.7.tar.gz :
  CHECKSUM(SHA256) this package     : 44bcc06360ceab9ee533e76973811c870979bce6938410dbc2f26876a92285b2
  CHECKSUM(SHA256) upstream package : 44bcc06360ceab9ee533e76973811c870979bce6938410dbc2f26876a92285b2


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1444552 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Hope this informal review is correct.

Cordially,


-- 
NVieville

Comment 3 Elliott Sales de Andrade 2017-07-07 08:46:17 UTC
A couple drive-by (informal) comments:
 * Why use GitHub source instead of PyPI? Upstream has bundled everything including docs and tests there, so it isn't lacking anything. It would reduce the number of %globals to track as well.
 * Docs are not built; the sources are in the tarball, so I don't see why they couldn't be built. Note that building docs would require additional dependencies [1].

The referenced .spec also shows how to run tests with nose, but I don't attempt to support RHEL builds.

[1] https://gitlab.com/qulogic-rpms/dask/blob/master/python-sortedcontainers/python-sortedcontainers.spec#L16

Comment 4 Elliott Sales de Andrade 2017-08-23 05:28:52 UTC
I would like to get this into Fedora. Please respond or this review might have to be closed as stalled.

Comment 5 Zbigniew Jędrzejewski-Szmek 2017-09-02 08:59:04 UTC
Elliott, I think you can continue. There has been no reply from the original submitter since April.

Comment 6 Elliott Sales de Andrade 2017-09-03 01:22:36 UTC
Closing in favour of new review.

*** This bug has been marked as a duplicate of bug 1487884 ***


Note You need to log in before you can comment on or make changes to this bug.